
	;PPU֌W
	.import		_wait_nmi
	.import		_waitvblank
	.import		_clear
	.import		_ppu_print

	;L[֌W
	.import		_inkey
	.import		_now_key

	;ꎞ[NGA
	.importzp	tmp1,tmp2,tmp3,tmp4
	.importzp	ptr1,ptr2,ptr3,ptr4

	.export	_play_bgm
	.export	_stop_bgm
	.export	_play_se
	.export	_stop_se
	.export	_sound_test

	.include	"gekioko.inc"

	.import	_MUS_BGM0
	.import	_MUS_BGM1
	.import	_MUS_BGM2
	.import	_MUS_BGM3
	.import	_MUS_BGM4
	.import	_MUS_BGM5
	.import	_MUS_BGM6
	.import	_MUS_BGM7
	.import	_MUS_BGM8

	.import	_MUS_SE0
	.import	_MUS_SE1

.rodata
bgm:	.word	_MUS_BGM0
	.word	_MUS_BGM1
	.word	_MUS_BGM2
	.word	_MUS_BGM3
	.word	_MUS_BGM4
	.word	_MUS_BGM5
	.word	_MUS_BGM6
	.word	_MUS_BGM7
	.word	_MUS_BGM8

se:	.word	_MUS_SE0
	.word	_MUS_SE1

;===============================================================
;		Music Play
;---------------------------------------------------------------
;  << Input >>
;	A	Music number
;  << Output >>
;		None
;  <<  >>
;===============================================================
.code
.proc	_play_bgm
	asl	a
	tay
	lda	bgm,y
	ldx	bgm + 1,y
	jmp	_nsd_play_bgm
.endproc

;===============================================================
;		Stop Music
;---------------------------------------------------------------
;  << Input >>
;		None
;  << Output >>
;		None
;  <<  >>
;===============================================================
.proc	_stop_bgm
	jmp	_nsd_stop_bgm
.endproc

;===============================================================
;		SE Play
;---------------------------------------------------------------
;  << Input >>
;	A	Music number
;  << Output >>
;		None
;  <<  >>
;===============================================================
.code
.proc	_play_se
	asl	a
	tay
	lda	se,y
	ldx	se + 1,y
	jmp	_nsd_play_se
.endproc

;===============================================================
;		SE Music
;---------------------------------------------------------------
;  << Input >>
;		None
;  << Output >>
;		None
;  <<  >>
;===============================================================
.proc	_stop_se
	jmp	_nsd_stop_se
.endproc

;===============================================================
;		SE Music
;---------------------------------------------------------------
;  << Input >>
;		None
;  << Output >>
;		None
;  <<  >>
;===============================================================
.rodata
mus0:	.byte	"EXIT"
mus0_e:

mus1:	.byte	"TITLE          M. NAMIKI"	;24
mus2:	.byte	"STAGE 4        CHIBIFAI "
mus3:	.byte	"STAGE X                 "
mus4:	.byte	"GAME OVER      YUMI     "
mus5:	.byte	"NANGOKU STAGE  ROPHON   "
mus6:	.byte	"SADNESS VALSE  S.W.     "
mus7:	.byte	"STAGE 3        YUMI     "
mus8:	.byte	"JUNGLE         HYDDEN   "
mus9:	.byte	"STAGE 1   PROF.SAKAMOTO "


mus_cursol:	.byte	"@"
mus_space:	.byte	" "

;	tmp3	now
;	tmp4	old

.code
.proc	_sound_test

	jsr	_clear

	lda	#1
	sta	tmp3
	lda	#0
	sta	tmp4

	;MSG0
	lda	#<(mus0)
	sta	ptr1
	lda	#>(mus0)
	sta	ptr1 + 1
	ldx	#4
	ldy	#10
	lda	#(mus0_e - mus0)
	jsr	_ppu_print

	;MSG1
	lda	#<(mus1)
	sta	ptr1
	lda	#>(mus1)
	sta	ptr1 + 1
	ldx	#4
	ldy	#11
	lda	#24
	jsr	_ppu_print

	;MSG2
	lda	#<(mus2)
	sta	ptr1
	lda	#>(mus2)
	sta	ptr1 + 1
	ldx	#4
	ldy	#12
	lda	#24
	jsr	_ppu_print

	;MSG3
	lda	#<(mus3)
	sta	ptr1
	lda	#>(mus3)
	sta	ptr1 + 1
	ldx	#4
	ldy	#13
	lda	#24
	jsr	_ppu_print

	;MSG4
	lda	#<(mus4)
	sta	ptr1
	lda	#>(mus4)
	sta	ptr1 + 1
	ldx	#4
	ldy	#14
	lda	#24
	jsr	_ppu_print

	;MSG5
	lda	#<(mus5)
	sta	ptr1
	lda	#>(mus5)
	sta	ptr1 + 1
	ldx	#4
	ldy	#15
	lda	#24
	jsr	_ppu_print

	;MSG6
	lda	#<(mus6)
	sta	ptr1
	lda	#>(mus6)
	sta	ptr1 + 1
	ldx	#4
	ldy	#16
	lda	#24
	jsr	_ppu_print

	;MSG7
	lda	#<(mus7)
	sta	ptr1
	lda	#>(mus7)
	sta	ptr1 + 1
	ldx	#4
	ldy	#17
	lda	#24
	jsr	_ppu_print

	;MSG8
	lda	#<(mus8)
	sta	ptr1
	lda	#>(mus8)
	sta	ptr1 + 1
	ldx	#4
	ldy	#18
	lda	#24
	jsr	_ppu_print

	;MSG8
	lda	#<(mus9)
	sta	ptr1
	lda	#>(mus9)
	sta	ptr1 + 1
	ldx	#4
	ldy	#19
	lda	#24
	jsr	_ppu_print

LOOP:
	lda	#0
	jsr	_inkey

JOY_Down_Check:
	lda	#JOY_Down
	bit	_now_key
	beq	@exit
	lda	tmp3
	sta	tmp4
	add	#1
	cmp	#10
	bcs	@Down
	sta	tmp3
	lda	#0
	jsr	_play_se
@Down:
@exit:

JOY_Up_Check:
	lda	#JOY_Up
	bit	_now_key
	beq	@exit
	lda	tmp3
	sta	tmp4
	sub	#1
	bmi	@Up
	sta	tmp3
	lda	#0
	jsr	_play_se
@Up:
@exit:

PrintCursol:
	lda	tmp3
	cmp	tmp4
	beq	@exit
	;MSG1
	lda	#<(mus_cursol)
	sta	ptr1
	lda	#>(mus_cursol)
	sta	ptr1 + 1
	ldx	#2
	lda	#10
	add	tmp3		;now cursol
	tay
	lda	#1
	jsr	_ppu_print
	;MSG2
	lda	#<(mus_space)
	sta	ptr1
	lda	#>(mus_space)
	sta	ptr1 + 1
	ldx	#2
	lda	#10
	add	tmp4		;old cursol
	tay
	lda	#1
	jsr	_ppu_print
	lda	tmp3
	sta	tmp4
@exit:

JOY_A_Check:
	lda	#JOY_A
	bit	_now_key
	beq	@exit

	lda	tmp3
	cmp	#0
	beq	EXIT
@l1:	sub	#1
	jsr	_play_bgm
@exit:
;	jsr	_wait_nmi
	jmp	LOOP

EXIT:

	lda	#0
	rts
.endproc
