
;	.import		ppubuf_waitempty

	;PPU֌W
	.import		_wait_nmi
	.import		_waitvblank
	.import		_clear
	.import		_set_ppu_ctrl		;PPU_CTRL1ݒ
	.import		_ret_ppu_ctrl		;PPU_CTRL1A
	.import		_ppu_set_palette
	.import		_ppu_set_nametable
	.import		_ppu_set_sprite
;	.import		_ppu_sprite_dma
	.import		_ppu_print

	.import		_ppu_sprite_buff
	.import		_ppu_sprite_flag

	;BGM֌W
	.import		_play_bgm
	.import		_play_se

	;L[֌W
	.import		_inkey
	.import		_now_key

	;ꎞ[NGA
	.importzp	tmp1,tmp2,tmp3,tmp4
	.importzp	ptr1,ptr2,ptr3,ptr4

	;O錾
	.export		_title
	.export		_title_draw

	.include	"gekioko.inc"

;===============================================================
;	char	__fastcall__	_title(void);
;---------------------------------------------------------------
;	Summary :		Title
;	Arguments :	none	
;	Return :	a	return code
;	Modifies :	A X Y	
;	Useage :		
;===============================================================
;
;	tmp3	now cursol
;	tmp4	old cursol
;

.rodata
title_msg1:	.byte	"1 PLAYER"
title_msg1_e:
title_msg2:	.byte	"2 PLAYERS"
title_msg2_e:

title_cursol:	.byte	"@"
title_cursol_e:
title_space:	.byte	" "
title_space_e:

.code
.proc	_title

	jsr	_clear
	jsr	_title_draw

	lda	#0
	jsr	_play_bgm

	;MSG1
	lda	#<(title_msg1)
	sta	ptr1
	lda	#>(title_msg1)
	sta	ptr1 + 1
	ldx	#13
	ldy	#21
	lda	#(title_msg1_e - title_msg1)
	jsr	_ppu_print

	;MSG2
	lda	#<(title_msg2)
	sta	ptr1
	lda	#>(title_msg2)
	sta	ptr1 + 1
	ldx	#13
	ldy	#23
	lda	#(title_msg2_e - title_msg2)
	jsr	_ppu_print

	lda	#0
	sta	tmp3
	lda	#2
	sta	tmp4



LOOP:	
	lda	#0
	jsr	_inkey

JOY_Down_Check:
	lda	#JOY_Down
	bit	_now_key
	beq	@exit
	lda	tmp3
	sta	tmp4
	add	#2
	cmp	#4
	bcs	@Down
	sta	tmp3
	lda	#0
	jsr	_play_se
@Down:
@exit:

JOY_Up_Check:
	lda	#JOY_Up
	bit	_now_key
	beq	@exit
	lda	tmp3
	sta	tmp4
	sub	#2
	bmi	@Up
	sta	tmp3
	lda	#0
	jsr	_play_se
@Up:
@exit:

PrintCursol:
	lda	tmp3
	cmp	tmp4
	beq	@exit
	;MSG1
	lda	#<(title_cursol)
	sta	ptr1
	lda	#>(title_cursol)
	sta	ptr1 + 1
	ldx	#11
	lda	#21
	add	tmp3		;now cursol
	tay
	lda	#(title_cursol_e - title_cursol)
	jsr	_ppu_print
	;MSG2
	lda	#<(title_space)
	sta	ptr1
	lda	#>(title_space)
	sta	ptr1 + 1
	ldx	#11
	lda	#21
	add	tmp4		;old cursol
	tay
	lda	#(title_space_e - title_space)
	jsr	_ppu_print
	lda	tmp3
	sta	tmp4
@exit:

SoundTestCheck:
	lda	#(JOY_A + JOY_B + JOY_Right)
	cmp	_now_key
	bne	@exit
	lda	#99
	rts
@exit:

JOY_A_Check:
	lda	#JOY_A
	bit	_now_key
	beq	@exit
	lda	#1
	jsr	_play_se
	lda	tmp3
	cmp	#0
	bne	@l1
	lda	#1
	rts
@l1:	cmp	#2
	bne	@l2
	lda	#2
	rts
@l2:
@exit:
;	jsr	_wait_nmi
	jmp	LOOP

.endproc
;===============================================================
;	void	__fastcall__	_title_draw(void);
;---------------------------------------------------------------
;	Summary :		Draw the title
;	Arguments :	none	
;	Return :	none	
;	Modifies :	A X Y	
;	Useage :		
;===============================================================
.code
.proc	_title_draw

	;-----------------------
	;\
	lda	#%10110000
	sta	PPU_CTRL1

	lda	#%00000000
	sta	PPU_CTRL2

; Wait for vblank
	jsr	_wait_nmi		;VRAM̍XV͉ʂĂ

	;-----------------------
	;l[e[u
	lda	#<(title_name)
	ldx	#>(title_name)
	ldy	#0
	jsr	_ppu_set_nametable

	;-----------------------
	;pbg
	lda	#<(title_palette)
	ldx	#>(title_palette)
	ldy	#0
	jsr	_ppu_set_palette
	lda	#<(title_palette)
	ldx	#>(title_palette)
	ldy	#1
	jsr	_ppu_set_palette

;	;PPȔ݃obt@ɂȂ܂ő҂B
;	jsr	ppubuf_waitempty	;XvCg̑OɁAVRAM݂̏I点B


	;-----------------------
	;PPUݒiVblank荞݊Jnj
	lda	#%10110000
	jsr	_set_ppu_ctrl

	;-----------------------
	;XvCgiXvCgNMI荞ݖ̃XvCgDMAŐݒ肷j

	lda	#<(title_sprite)
	sta	ptr1
	lda	#>(title_sprite)
	sta	ptr1 + 1

	ldy	#0

	;XvCg`eAcl`p݃obt@֓]
@L0:	lda	(ptr1),y
	sta	_ppu_sprite_buff+4,y		; 0 0ep
	iny
	cpy	#4*15			;Kvȕݒito do cursolj
	bne	@L0
;	jsr	_ppu_sprite_dma

	;-----------------------
	;\߂
	jsr	_wait_nmi		;\ońAVblankԒɎ{B
	lda	#%00011110
	sta	PPU_CTRL2		;\L

	rts
.endproc

;-----------------------------------------------------------------------------

.rodata
title_sprite:	;y   n    a    x
	.byte	$47, $02, $02, $0E	;01
	.byte	$57, $04, $02, $0E	;02
	.byte	$45, $06, $02, $16	;03
	.byte	$55, $08, $02, $16	;04
	.byte	$43, $0A, $02, $1E	;05
	.byte	$53, $0C, $02, $1E	;06
	.byte	$41, $0E, $02, $26	;07
	.byte	$51, $10, $02, $26	;08
	.byte	$3F, $12, $02, $2E	;09
	.byte	$4F, $14, $02, $2E	;0A
	.byte	$3E, $16, $02, $36	;0B
	.byte	$4E, $18, $02, $36	;0C
	.byte	$3C, $1A, $02, $3E	;0D
	.byte	$4C, $1C, $02, $3E	;0E
	.byte	$4A, $1E, $02, $46	;0F

title_palette:
	.byte	$2C
	.byte	$0F
	.byte	$26
	.byte	$30
	.byte	$2C
	.byte	$0F
	.byte	$1A
	.byte	$37
	.byte	$2C
	.byte	$06
	.byte	$15
	.byte	$28
	.byte	$2C
	.byte	$0F
	.byte	$17
	.byte	$27

title_name:
	.incbin	"gekioko.nam"

